/**
 * * 生成一个不重复的ID
 * @param { Number } randomLength
 */
export const getUUID = (randomLength = 10) => {
  return 'id_' + Number(Math.random().toString().substring(2, randomLength) + Date.now()).toString(36)
}

/**
 * * JSON序列化，支持函数和 undefined
 * @param data
 */
export const JSONStringify = (data) => {
  return JSON.stringify(
    data,
    (key, val) => {
      // 处理函数丢失问题
      if (typeof val === 'function') {
        return `${val}`
      }
      // 处理 undefined 丢失问题
      if (typeof val === 'undefined') {
        return null
      }
      return val
    },
    2
  )
}
/**
 * * JSON反序列化，支持函数和 undefined
 * @param data
 */

export const JSONParse = (data) => {
  if (data.trim() === '') return
  return JSON.parse(data, (k, v) => {
    if (k !== 'formatter') {
      return v
    }
    // 还原函数值
    if (typeof v === 'string' && checkJsonStringify(v)) {
      return eval2(`(function(){return ${v}})()`)
    } else if (typeof v === 'string' && v.indexOf && v.indexOf('return ') > -1) {
      const baseLeftIndex = v.indexOf('(')
      if (baseLeftIndex > -1) {
        const newFn = `function ${v.substring(baseLeftIndex)}`
        return eval2(`(function(){return ${newFn}})()`)
      }
    }
    return v
  })
}

export const getParseLang = (data, lang) => {
  try {
    return JSON.parse(data)[lang];
  } catch (error) {
    return data;
  }
};


// 进行字段为空的判断
export function sanitizeObject(obj) {
  if (Array.isArray(obj)) {
    return obj.map(item => sanitizeObject(item));
  } else if (obj !== null && typeof obj === 'object') {
    const sanitized = {};
    for (const key in obj) {
      if (obj.hasOwnProperty(key)) {
        if (typeof obj[key] === 'string') {
          sanitized[key] = obj[key].trim() === '' ? '---' : obj[key];
        } else if (typeof obj[key] === 'object' && obj[key] !== null) {
          sanitized[key] = sanitizeObject(obj[key]);
        } else {
          sanitized[key] = obj[key];
        }
      }
    }
    return sanitized;
  }
  return obj;
}